aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/ipq806x/base-files
diff options
context:
space:
mode:
authorINAGAKI Hiroshi <musashino.open@gmail.com>2018-12-24 15:20:25 +0900
committerChristian Lamparter <chunkeey@gmail.com>2019-01-01 16:39:59 +0100
commit51fe956c4fbd6ea78f46a4aa835f142e94f32cee (patch)
treefd241b09e356baa4150380976314c27d8d71adac /target/linux/ipq806x/base-files
parent7e9b93fb1b9d1f04df905b77d79ef8a182b2fb83 (diff)
downloadupstream-51fe956c4fbd6ea78f46a4aa835f142e94f32cee.tar.gz
upstream-51fe956c4fbd6ea78f46a4aa835f142e94f32cee.tar.bz2
upstream-51fe956c4fbd6ea78f46a4aa835f142e94f32cee.zip
ipq806x: add support for Buffalo WXR-2533DHP
Buffalo WXR-2533DHP is a 2.4/5 GHz band 11ac router, based on Qualcomm IPQ8064. The U-Boot on WXR-2533DHP employs a complicated dual firmware protection scheme against corruptions of the kernel and rootfs images. See the notes in buffalo.sh for details. specifications: - Qualcomm IPQ8064 (384 - 1,400 MHz, 2C2T) - 512 MB of RAM (DDR3) - 256 MB of Flash (NAND) - 4T4R 2.4/5 GHz Wlan (QCA9980) - 5x 10/100/1000 Mbps Ethernet - 10x LEDs, 8x keys (6x buttons, 2x slide-switches) - 2x USB 3.0 Type-A - 12VDC/4A AC Adapter - UART through-hole on PCB - J3: Vcc, GND, TX, RX from USB port side - 115200n8 Boot instructions for the initramfs image: 1. Prepare the TFTP server with the initramfs image renamed to "wxr2300dhp-initramfs.uImage" and IP address "192.168.11.10". 2. Press the "AOSS" button while powering on the WXR-2533DHP. 3. Wait until the "Wireless" LED flashes before releasing the AOSS button. The WXR-2533DHP will grab the image from TFTP server and will boot it. Flashing instructions: To persistently write the firmware, flash an openwrt sysupgrade image from inside the initramfs, for example transfer via `scp <sysupgrade> root@192.168.1.1:/tmp` and flash on the device with `sysupgrade -n /tmp/<sysupgrade>`. Then wait ~120 seconds to let it finish the flashing process. Signed-off-by: INAGAKI Hiroshi <musashino.open@gmail.com> Signed-off-by: Christian Lamparter <chunkeey@gmail.com> [reworded message]
Diffstat (limited to 'target/linux/ipq806x/base-files')
-rwxr-xr-xtarget/linux/ipq806x/base-files/etc/board.d/01_leds4
-rwxr-xr-xtarget/linux/ipq806x/base-files/etc/board.d/02_network1
-rw-r--r--target/linux/ipq806x/base-files/etc/hotplug.d/firmware/11-ath10k-caldata8
-rw-r--r--target/linux/ipq806x/base-files/lib/upgrade/buffalo.sh45
-rw-r--r--target/linux/ipq806x/base-files/lib/upgrade/platform.sh5
5 files changed, 63 insertions, 0 deletions
diff --git a/target/linux/ipq806x/base-files/etc/board.d/01_leds b/target/linux/ipq806x/base-files/etc/board.d/01_leds
index 769afb8b85..509d334c41 100755
--- a/target/linux/ipq806x/base-files/etc/board.d/01_leds
+++ b/target/linux/ipq806x/base-files/etc/board.d/01_leds
@@ -11,6 +11,10 @@ board=$(board_name)
boardname="${board##*,}"
case "$board" in
+buffalo,wxr-2533dhp)
+ ucidef_set_led_wlan "wlan" "WLAN" "${boardname}:white:wireless" "phy0tpt"
+ ucidef_set_led_switch "wan" "WAN" "${boardname}:white:internet" "switch0" "0x20"
+ ;;
compex,wpq864)
ucidef_set_led_usbport "usb" "USB" "wpq864:green:usb" "usb1-port1" "usb2-port1"
ucidef_set_led_usbport "pcie-usb" "PCIe USB" "wpq864:green:usb-pcie" "usb3-port1"
diff --git a/target/linux/ipq806x/base-files/etc/board.d/02_network b/target/linux/ipq806x/base-files/etc/board.d/02_network
index 3417466fbb..a3aa0fce70 100755
--- a/target/linux/ipq806x/base-files/etc/board.d/02_network
+++ b/target/linux/ipq806x/base-files/etc/board.d/02_network
@@ -12,6 +12,7 @@ board_config_update
board=$(board_name)
case "$board" in
+buffalo,wxr-2533dhp |\
compex,wpq864 |\
netgear,d7800 |\
netgear,r7500 |\
diff --git a/target/linux/ipq806x/base-files/etc/hotplug.d/firmware/11-ath10k-caldata b/target/linux/ipq806x/base-files/etc/hotplug.d/firmware/11-ath10k-caldata
index ba7a8e0b14..e05f2b2c7b 100644
--- a/target/linux/ipq806x/base-files/etc/hotplug.d/firmware/11-ath10k-caldata
+++ b/target/linux/ipq806x/base-files/etc/hotplug.d/firmware/11-ath10k-caldata
@@ -79,6 +79,10 @@ board=$(board_name)
case "$FIRMWARE" in
"ath10k/pre-cal-pci-0000:01:00.0.bin")
case $board in
+ buffalo,wxr-2533dhp)
+ ath10kcal_extract "ART" 4096 12064
+ ath10kcal_patch_mac_crc $(mtd_get_mac_binary ART 30)
+ ;;
linksys,ea8500)
ath10kcal_extract "art" 4096 12064
ath10kcal_patch_mac_crc $(macaddr_add $(mtd_get_mac_ascii devinfo hw_mac_addr) +1)
@@ -109,6 +113,10 @@ case "$FIRMWARE" in
;;
"ath10k/pre-cal-pci-0001:01:00.0.bin")
case $board in
+ buffalo,wxr-2533dhp)
+ ath10kcal_extract "ART" 20480 12064
+ ath10kcal_patch_mac_crc $(mtd_get_mac_binary ART 24)
+ ;;
linksys,ea8500)
ath10kcal_extract "art" 20480 12064
ath10kcal_patch_mac_crc $(macaddr_add $(mtd_get_mac_ascii devinfo hw_mac_addr) +2)
diff --git a/target/linux/ipq806x/base-files/lib/upgrade/buffalo.sh b/target/linux/ipq806x/base-files/lib/upgrade/buffalo.sh
new file mode 100644
index 0000000000..77fa65e60e
--- /dev/null
+++ b/target/linux/ipq806x/base-files/lib/upgrade/buffalo.sh
@@ -0,0 +1,45 @@
+#!/bin/sh
+# Copyright (C) 2018 OpenWrt.org
+#
+
+. /lib/functions.sh
+
+# The mtd partition 'ubi' and 'rootfs_1' on NAND flash are os-image
+# partitions. These partitions are called as "Bank1/Bank2" in U-Boot
+# on WXR-2533DHP, and they are checked conditions when booting.
+# Then, U-Boot checks kernel and rootfs volumes in ubi, but U-Boot
+# needs "ubi_rootfs" as rootfs volume name. And, U-Boot checks the
+# checksum at the end of rootfs (ubi_rootfs).
+# When U-Boot writes os-image into the Bank, only kernel, rootfs
+# (ubi_rootfs) and rootfs_data (ubi_rootfs_data) volumes are wrote
+# into the Bank. (not full ubi image)
+#
+# == U-Boot Behaviors ==
+# - Bank1/Bank2 images are good, images are different
+# -> writes os-image to Bank1 from Bank2
+# (this behavior is used to firmware upgrade in stock firmware)
+# - Bank1 image is broken (or checksum error)
+# -> writes os-image to Bank1 from Bank2
+# - Bank2 image is broken (or checksum error)
+# -> writes os-image to Bank2 from Bank1
+# - Bank1/Bank2 images are broken (or checksum error)
+# -> start tftp
+
+buffalo_upgrade_prepare_ubi() {
+ local ubidev="$( nand_find_ubi ubi )"
+ local mtdnum2="$( find_mtd_index rootfs_1 )"
+
+ if [ ! "$mtdnum2" ]; then
+ echo "cannot find second ubi mtd partition rootfs_1"
+ return 1
+ fi
+
+ local ubidev2="$( nand_find_ubi rootfs_1 )"
+ if [ ! "$ubidev2" ] && [ -n "$mtdnum2" ]; then
+ ubiattach -m "$mtdnum2"
+ ubidev2="$( nand_find_ubi rootfs_1 )"
+ fi
+
+ ubirmvol /dev/$ubidev -N ubi_rootfs_data &> /dev/null || true
+ ubirmvol /dev/$ubidev2 -N kernel &> /dev/null || true
+}
diff --git a/target/linux/ipq806x/base-files/lib/upgrade/platform.sh b/target/linux/ipq806x/base-files/lib/upgrade/platform.sh
index 4b88f9cf5e..2f0190629e 100644
--- a/target/linux/ipq806x/base-files/lib/upgrade/platform.sh
+++ b/target/linux/ipq806x/base-files/lib/upgrade/platform.sh
@@ -10,6 +10,11 @@ platform_check_image() {
platform_do_upgrade() {
case "$(board_name)" in
+ buffalo,wxr-2533dhp)
+ buffalo_upgrade_prepare_ubi
+ CI_ROOTPART="ubi_rootfs"
+ nand_do_upgrade "$ARGV"
+ ;;
compex,wpq864|\
netgear,d7800 |\
netgear,r7500 |\